/********************************* AT_DMA.H ******************************

Copyright NCR Corporation Microelectronics Division January 1992

Author:		Ken Stewart NCR MPD Logic Products Applications Engineer
Purpose:	53C94 test software

This software was written by NCR Microelectronics to develop and test new
products.  It is not a general SCSI driver.  NCR assumes no liability for
its use, misuse or inability to use.

Project files:
		C94.C 		Main body of code
		TARGET.C	Target Mode routines
		C94ISR.C	Interrupt Service Routine
		C94TEST.C	Automatic Test Module
		AT_DMA.C	hardware dependant DMA stuff
		AT_DMA.H
		C94AT.H		hardware addresses, global defines
		C94EV.H		external variables
				  **************/

/* 8237A DMA controller register addresses in the IBM AT */

#define dma5_page	0x8B	/* DMA channel 5 page register	    */
#define dma5_addrs	0xC4	/* DMA channel 5 address pointer    */
#define dma5_count	0xC6	/* DMA channel 5 transfer count	    */

#define dma7_page	0x8A	/* DMA channel 7 page register	    */
#define dma7_addrs	0xCC	/* DMA channel 7 address pointer    */
#define dma7_count	0xCE	/* DMA channel 7 transfer count	    */

#define	dma_status	0xD0	/* DMA Read Status Register	    */
#define dma_command	0xD0	/* DMA Write Command Register	    */
#define dma_request	0xD2	/* DMA Write Request Register	    */
#define dma_mask	0xD4	/* DMA Write Single Mask Register   */
#define dma_mode	0xD6	/* DMA Write Mode Register	    */
#define dma_flop	0xD8	/* DMA Clear Byte Pointer Flip Flop */

/* 8237 DMA controller bit settings for the AT.
   Appropriate bits should be OR'ed together */

#define ch4		0x00	/* DMA channel 4 */
#define ch5		0x01	/* DMA channel 5 */
#define ch6		0x02	/* DMA channel 6 */
#define ch7		0x03    /* DMA channel 7 */

#define WT		0x04	/* mode register memory write */
#define RD		0x08	/* mode register memory read  */

#define demand		0x00	/* mode register demand mode     */
#define single		0x40	/* mode register single transfer */
#define block		0x80	/* mode register block transfer  */
#define cascade		0xC0    /* mode register cascade mode    */

void calc_abs_adrs (void far *ptr);

unsigned char            lsB, mdB, msB;



